package solutions.bitbadger.documents.scala

import org.scalatest.funspec.AnyFunSpec
import org.scalatest.matchers.should.Matchers
import solutions.bitbadger.documents.{AutoId, Configuration, Dialect, DocumentException}

class ConfigurationSpec extends AnyFunSpec with Matchers {

  describe("idField") {
    it("defaults to `id`") {
      Configuration.idField shouldEqual "id"
    }
  }

  describe("autoIdStrategy") {
    it("defaults to `DISABLED`") {
      Configuration.autoIdStrategy shouldEqual AutoId.DISABLED
    }
  }

  describe("idStringLength") {
    it("defaults to 16") {
      Configuration.idStringLength shouldEqual 16
    }
  }

  describe("dialect") {
    it("is derived from connection string") {
      try {
        an [DocumentException] should be thrownBy Configuration.dialect()
        Configuration.setConnectionString("jdbc:postgresql:db")
        Configuration.dialect() shouldEqual Dialect.POSTGRESQL
      } finally {
        Configuration.setConnectionString(null)
      }
    }
  }
}
