package solutions.bitbadger.documents.scala

import org.scalatest.funspec.AnyFunSpec
import org.scalatest.matchers.should.Matchers
import solutions.bitbadger.documents.Op

class OpSpec extends AnyFunSpec with Matchers {

  describe("sql") {
    it("returns = for EQUAL") {
      Op.EQUAL.getSql shouldEqual "="
    }
    it("returns > for GREATER") {
      Op.GREATER.getSql shouldEqual ">"
    }
    it("returns >= for GREATER_OR_EQUAL") {
      Op.GREATER_OR_EQUAL.getSql shouldEqual ">="
    }
    it("returns < for LESS") {
      Op.LESS.getSql shouldEqual "<"
    }
    it("returns <= for LESS_OR_EQUAL") {
      Op.LESS_OR_EQUAL.getSql shouldEqual "<="
    }
    it("returns <> for NOT_EQUAL") {
      Op.NOT_EQUAL.getSql shouldEqual "<>"
    }
    it("returns BETWEEN for BETWEEN") {
      Op.BETWEEN.getSql shouldEqual "BETWEEN"
    }
    it("returns IN for IN") {
      Op.IN.getSql shouldEqual "IN"
    }
    it("returns ??| for IN_ARRAY") {
      Op.IN_ARRAY.getSql shouldEqual "??|"
    }
    it("returns IS NOT NULL for EXISTS") {
      Op.EXISTS.getSql shouldEqual "IS NOT NULL"
    }
    it("returns IS NULL for NOT_EXISTS") {
      Op.NOT_EXISTS.getSql shouldEqual "IS NULL"
    }
  }
}
