package solutions.bitbadger.documents.scala

import org.scalatest.funspec.AnyFunSpec
import org.scalatest.matchers.should.Matchers
import solutions.bitbadger.documents.ParameterName

class ParameterNameSpec extends AnyFunSpec with Matchers {

  describe("derive") {
    it("works when given existing names") {
      val names = new ParameterName()
      names.derive(":taco") shouldEqual ":taco"
      names.derive(null) shouldEqual ":field0"
    }
    it("works when given all anonymous fields") {
      val names = new ParameterName()
      names.derive(null) shouldEqual ":field0"
      names.derive(null) shouldEqual ":field1"
      names.derive(null) shouldEqual ":field2"
      names.derive(null) shouldEqual ":field3"
    }
  }
}
