package solutions.bitbadger.documents.scala

import org.scalatest.funspec.AnyFunSpec
import org.scalatest.matchers.should.Matchers
import solutions.bitbadger.documents.{DocumentException, Parameter, ParameterType}

class ParameterSpec extends AnyFunSpec with Matchers {

  describe("constructor") {
    it("succeeds with colon-prefixed name") {
      val p = new Parameter(":test", ParameterType.STRING, "ABC")
      p.getName shouldEqual ":test"
      p.getType shouldEqual ParameterType.STRING
      p.getValue shouldEqual "ABC"
    }
    it("succeeds with at-sign-prefixed name") {
      val p = Parameter("@yo", ParameterType.NUMBER, null)
      p.getName shouldEqual "@yo"
      p.getType shouldEqual ParameterType.NUMBER
      p.getValue should be (null)
    }
    it("fails with incorrect prefix") {
      an [DocumentException] should be thrownBy Parameter("it", ParameterType.JSON, "")
    }
  }
}
